(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@musical-patterns/id"), require("@musical-patterns/material"), require("@musical-patterns/utilities"), require("@musical-patterns/spec"));
	else if(typeof define === 'function' && define.amd)
		define(["@musical-patterns/id", "@musical-patterns/material", "@musical-patterns/utilities", "@musical-patterns/spec"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@musical-patterns/id"), require("@musical-patterns/material"), require("@musical-patterns/utilities"), require("@musical-patterns/spec")) : factory(root["@musical-patterns/id"], root["@musical-patterns/material"], root["@musical-patterns/utilities"], root["@musical-patterns/spec"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__824__, __WEBPACK_EXTERNAL_MODULE__735__, __WEBPACK_EXTERNAL_MODULE__999__, __WEBPACK_EXTERNAL_MODULE__918__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 377:
/***/ ((module) => {

// Module
var code = "<div class=\"row\"> <div class=\"middle\"> <p> <i> Given a number, repeatedly metrically modulate by either the <a href=\"https://en.wikipedia.org/wiki/Superparticular_ratio\" target=\"_blank\">superparticular ratio</a> or the subparticular ratio which has it as its numerator, at each point choosing — of these two ratios — the one which strays least from the original duration, and finally wrapping the piece when you've reached a meter very close to the original. </i> </p> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <h3> Core Cycles </h3> </div> <div class=\"right\"></div> </div> <div class=\"row\"> <div class=\"middle\"> <p> The first major step in materializing a Beaten Path is computing the <b>core cycle</b>. To do so, we need only a single parameter, what we call the <b>core</b>. The cycle is a series of values, starting with <b>1</b> and ending by wrapping back around to that same <b>1</b> (hence it being a cycle), where each next value in the cycle is found by multiplying the previous value by one of two important rationals which each <b>core</b> is associated with: a superparticular rational, and a subparticular rational. The superparticular is the rational <b>core / (core - 1)</b>. The subparticular is the rational <b>core / (core + 1)</b>. The cycle ends when you have arrived at a value that is extremely close to <b>1</b> again. </p> </div> <div class=\"right\"> <p> e.g., for core = 5, multiplying each step by either 5/6 or 5/4: <br> 1 / 1 <br> 5 / 6 <br> 25 / 24 <br> 125 / 144 <br> 625 / 576 <br> ... <br> 95367431640625 / 95105071448064 ≈ 1 </p> </div> </div> <div class=\"row\"> <div class=\"middle\"> <h3> Commas </h3> <p> You can never <i>exactly</i> reach <b>1</b> again, for a simple reason: Because each new factor in the numerator is <i>always</i> the core, and each new factor in the denominator is <i>never</i> the core, you can never cancel anything out, so the factorization grows increasingly complex forever. </p> <p> In spite of this bottomless pit of complexity, though, moments of near-convergence exist. For example, when core is <b>4</b>, you will be repeatedly multiplying either <b>4/3</b> or <b>4/5</b>. The first several values are: </p> <p> <b> 1 / 1 <br> 4 / 5 <br> 16 / 15 <br> 64 / 75 <br> 256 / 225 <br> </b> </p> <p> If you keep going, eventually we find a value very close to <b>1 / 1</b>: </p> <p> <b>4294967296 / 4271484375</b> </p> <p> In decimal expansion that's <b>≈1.0054976019899406</b>. </p> <p> And in terms of its factorization, that requires sixteen steps to complete, because it has thirty-two <b>2</b>'s in the numerator (two for each <b>4</b>, the <b>core</b>) and it has seven <b>3</b>'s and nine <b>5</b>'s in the denominator. </p> <p> Since that value is so close to <b>1</b>, we don't actually include it in the cycle. Instead, we just connect our cycle's end back up to it's beginning at this point. No one should notice that we moved to <b>1</b> instead of to <b>4294967296 / 4271484375</b>. </p> <p> Such tiny ratios are known in the biz as <a href=\"https://en.xen.wiki/w/Comma\" target=\"_blank\">commas</a>. The comma for core 4 is known as the <a href=\"https://en.xen.wiki/w/Escapade_comma\" target=\"_blank\">escapade comma</a>. </p> <p> There are simpler commas which use only <b>4</b>'s on one side and only <b>3</b>'s and <b>5</b>'s on the other. For example, the \"misty comma\" has thirteen <b>2</b>'s in the numerator, and twelve <b>3</b>'s and three <b>5</b>'s in the denominator. At <b>67108864 / 66430125 ≈ 1.01021733739</b> it's not quite as close to 1, but there's a more important reason it is not the comma for core 4: You could not arrive at by following the Beaten Path process. The fact that there are thirteen <b>4</b>'s in the numerator suggests that the cycle completes in thirteen steps. However, that means there must be a total of thirteen <b>3</b>'s and <b>5</b>'s on the other side, one for each rational we multiplied with a <b>4</b> in the numerator. As we can see, though, there are twelve plus three equals fifteen factors in the denominator. </p> <p> In other words, Beaten Path is less about the commas it happens to arrive at, and more about the path through them. </p> <h3> Absolute Ratio </h3> <p> But how do we pick which of the two - super- or sub-particular - we move by each step? Good question. Really, kind of \"the\" question of Beaten Path. The defining constraint of the Beaten Path process is that each next rational is the one which, when you multiply it with the current value, gets you the closest to 1. </p> <p> We decide this by comparing the \"absolute ratios\" of the two possibilities. If an absolute value is for ensuring all values are on the same side of the additive identity, 0, then an absolute ratio is for ensuring all values are on the same side of the multiplicative identity, 1. In other words, if your value is greater than 1, take its reciprocal. That way we can compare the two possibilities, even if one is above <b>1</b> and one is below. </p> <p> For example, consider this step from <b>core</b> of <b>3</b>, ten steps in, where our value is <b>59049 / 65536</b>. As usual, we have the choice of moving by either <b>3 / 4</b> or <b>3 / 2</b>. If we moved by <b>3 / 4</b> we would get <b>177147 / 262144</b>. If we moved by <b>3 / 2</b> we would get <b>177147 / 131072</b>. So which is closer to <b>1</b>, then: <b>177147 / 262144</b>, or <b>177147 / 131072</b>? </p> <p> Allow me to interrupt myself by first illustrating an important approach <i>not</i> to take (based on experience). Consider the two values' decimal expansions, <b>0.67576217651</b> and <b>1.35152435303</b>, respectively. We may be tempted to say that the former of the two is closer to <b>1</b>; the traditional absolute value of the difference between <b>1</b> and <b>0.67576217651</b> is only <b>0.32423782349</b> while the traditional absolute value of the difference between <b>1</b> and <b>1.35152435303</b> is a bit bigger at <b>0.35152435303</b>. However, comparing these two values arithmetically is unfair to the greater of the two. The lesser will only ever shrink in a range from 1 to approaching 0, while the greater can grow ad infinitum. We need an operation that equalizes the scale of both sides of the multiplicative identity. Enter absolute ratio. </p> <p> If we take the reciprocal of <b>177147 / 131072</b> so that it is also less than <b>1</b>, then we can compare it with <b>177147 / 262144</b>. So, finally, which is closer to <b>1</b>: <b>177147 / 262144</b>, or <b>131072 / 177147</b>? <b>131072 / 177147 ≈ 0.7399052764</b>. Recall that <b>177147 / 262144</b> was <b>0.67576217651</b>. So the answer which is closest to 1, as it turns out, is <b>131072 / 177147</b>! Perhaps surprisingly, the value with the greater absolute value difference is actually the value which is closer to <b>1</b> in the multiplicative sense. </p> <h3> Features </h3> <p> All this still is not enough information to create music. Well, it's easy enough to express this process musically. Assign note durations to the values of the core cycle. That way, as the piece moves from value to value, metric modulation occurs repeatedly, until finally upon wrapping around, we return to a beat value able to be conflated with the initial. </p> <p> Finally, to bring the music to life, assign the pitch as the reciprocal of the duration. As the duration goes down, the frequency goes up proportionally. In other words, every note will have the same number of vibrations. </p> <h3> Entities </h3> <p> Beaten Path may be articulated by a single entity. In this case the entity simply sounds each value of the cycle, and repeats. </p> <p> However, things get a bit more interesting when you start adding more entities. </p> <p> The rule here is that at no point is any entity playing the same note as any other entity. However, they are all playing sequential notes from the core cycle. With two entities, they'd begin the piece with one playing the first first value, the other playing the second. With three entities, they'd begin the piece by playing values 1, 2, and 3, respectively. </p> <p> Each note has a different pitch, so they form a chord together. But the fact that they each have a different duration poses a problem: how to keep the entities together? Assuming we want to keep them together, somewhat like typical music with chord progressions and a chord per measure and such. Well, the answer to this is: take the lowest common multiple of all of the entities' values, and use that as your bar length. Each entity repeats its note however many times it takes to fill that duration, but when that duration comes and every entity is in sync, that's our opportunity to make a change as we go to a new bar. </p> <p> Only one entity changes at a time. The entities leapfrog through the values of the core cycle. That is, when it is an entity's turn to advance through the core cycle, it jumps to the first value which is not currently reached by any other entity yet. In this way, the chord that the entities make together changes only one of its pitches each new bar. And each entity stays on each note it plays a number of bars equal to the entity count before changing to the next note. </p> <h3> Loop </h3> <p> When the count of entities does not divide evenly into the core cycle length, we find ourselves in a situation where we have completed a core cycle — what we call a <b>loop</b> — but the entities won't line up with each other. In other words, the entity whose turn it is to jump will not be wanting to jump to the note it played in the first bar. Instead it will be wanting to jump to the first note some other entity played. </p> <p> No problem though. It just means that the pattern in its entirety will be extended long enough that it fits the lowest common multiple of the entity count and the core cycle length. It'll keep repeating the core cycle, each time the entities trading places, until finally the entities have traded all the way back to their original positions. </p> </div> <div class=\"right\"></div> </div> ";
// Exports
module.exports = code;

/***/ }),

/***/ 824:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__824__;

/***/ }),

/***/ 735:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__735__;

/***/ }),

/***/ 918:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__918__;

/***/ }),

/***/ 999:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__999__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "pattern": () => (/* reexport */ pattern),
  "patterns": () => (/* reexport */ patterns)
});

// EXTERNAL MODULE: external "@musical-patterns/id"
var id_ = __webpack_require__(824);
// EXTERNAL MODULE: external "@musical-patterns/material"
var material_ = __webpack_require__(735);
// EXTERNAL MODULE: external "@musical-patterns/utilities"
var utilities_ = __webpack_require__(999);
;// CONCATENATED MODULE: ./src/material/custom/constants.ts
// tslint:disable no-magic-numbers

var INITIAL_CORE_DURATION = utilities_.as.Scalar(1);
var ADJUSTMENT_SIZE_BELOW_WHICH_IT_MATTERS_NOT_AND_BREAKS_THE_TOTAL_DURATION_CALCULATION = 1 / 10000;


;// CONCATENATED MODULE: ./src/material/custom/coreCycles.ts


var isUpwardsDurationCloserToOriginalDurationOfOne = function (maybeNextUpwardsDuration, maybeNextDownwardsDuration) {
    return (0,utilities_.absoluteRatio)(utilities_.as.number(maybeNextUpwardsDuration)) > (0,utilities_.absoluteRatio)(utilities_.as.number(maybeNextDownwardsDuration));
};
var computeCoreCycles = function (core) {
    var coreDurations = utilities_.as.Cycle([INITIAL_CORE_DURATION]);
    var coreIntervals = utilities_.as.Cycle([]);
    var rawCore = utilities_.as.number(core);
    var superparticular = utilities_.as.Scalar((0,utilities_.reciprocal)(utilities_.use.Cardinal(rawCore, utilities_.INCREMENT)));
    var superparticularDurationScalar = utilities_.as.Scalar(utilities_.use.Scalar(rawCore, superparticular));
    var superparticularDenominator = utilities_.as.Denominator(utilities_.use.Cardinal(rawCore, utilities_.INCREMENT));
    var superparticularInterval = [utilities_.as.Numerator(rawCore), superparticularDenominator];
    var subparticularDivisor = utilities_.as.Scalar((0,utilities_.reciprocal)(utilities_.use.Cardinal(rawCore, utilities_.DECREMENT)));
    var subparticularDurationScalar = utilities_.as.Scalar(utilities_.use.Scalar(rawCore, subparticularDivisor));
    var subparticularDenominator = utilities_.as.Denominator(utilities_.use.Cardinal(rawCore, utilities_.DECREMENT));
    var subparticularInterval = [utilities_.as.Numerator(rawCore), subparticularDenominator];
    var hasLooped = false;
    while (!hasLooped) {
        var previousDuration = (0,utilities_.finalElement)(coreDurations);
        var maybeNextUpwardsDuration = utilities_.use.Scalar(previousDuration, superparticularDurationScalar);
        var maybeNextDownwardsDuration = utilities_.use.Scalar(previousDuration, subparticularDurationScalar);
        if (isUpwardsDurationCloserToOriginalDurationOfOne(maybeNextUpwardsDuration, maybeNextDownwardsDuration)) {
            if ((0,utilities_.isCloseTo)(maybeNextUpwardsDuration, INITIAL_CORE_DURATION)) {
                hasLooped = true;
            }
            else {
                coreDurations.push(maybeNextUpwardsDuration);
            }
            coreIntervals.push(superparticularInterval);
        }
        else {
            if ((0,utilities_.isCloseTo)(maybeNextDownwardsDuration, INITIAL_CORE_DURATION)) {
                hasLooped = true;
            }
            else {
                coreDurations.push(maybeNextDownwardsDuration);
            }
            coreIntervals.push(subparticularInterval);
        }
    }
    return {
        coreDurations: coreDurations,
        coreIntervals: coreIntervals,
    };
};


;// CONCATENATED MODULE: ./src/material/custom/segmentValueIndices.ts

var computeSegmentValueIndices = function (_a) {
    var segmentIndex = _a.segmentIndex, entityCount = _a.entityCount;
    var segmentValueIndices = [];
    for (var entityDurationIndex = utilities_.INITIAL; entityDurationIndex <= (0,utilities_.insteadOf)((0,utilities_.finalIndexFromElementsTotal)(entityCount)); entityDurationIndex = utilities_.use.Cardinal(entityDurationIndex, utilities_.INCREMENT)) {
        var initialEntityDurationIndex = utilities_.use.Cardinal((0,utilities_.insteadOf)((0,utilities_.finalIndexFromElementsTotal)(entityCount)), utilities_.as.Cardinal((0,utilities_.ofNotAs)((0,utilities_.negative)(entityDurationIndex))));
        var entityCoreCycleProgressBeforeStepping = utilities_.use.Transition(segmentIndex, utilities_.as.Transition(utilities_.as.number(entityDurationIndex)));
        var entityCoreCycleProgressAfterStepping = utilities_.as.Transition(utilities_.use.Multiple((0,utilities_.floor)(utilities_.as.number(entityCoreCycleProgressBeforeStepping) / utilities_.as.number(entityCount)), utilities_.as.Multiple(utilities_.as.number(entityCount))));
        segmentValueIndices.push(utilities_.use.Cardinal(initialEntityDurationIndex, entityCoreCycleProgressAfterStepping));
    }
    return segmentValueIndices;
};


;// CONCATENATED MODULE: ./src/material/custom/segmentPieceLength/alignSegmentPieceLengthsWithSegmentValues.ts
var __read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};

var alignSegmentPieceLengthsWithSegmentValues = function (_a) {
    var segmentPieceLengths = _a.segmentPieceLengths, segmentValueIndices = _a.segmentValueIndices;
    var leastSegmentValueIndex = utilities_.min.apply(void 0, __spreadArray([], __read(segmentValueIndices), false));
    var segmentPieceLengthsIndices = segmentValueIndices.map(function (segmentValueIndex) {
        return (0,utilities_.insteadOf)(utilities_.use.Cardinal(segmentValueIndex, utilities_.as.Cardinal((0,utilities_.ofNotAs)((0,utilities_.negative)(leastSegmentValueIndex)))));
    });
    return segmentPieceLengthsIndices.map(function (segmentPieceLengthsIndex) {
        return utilities_.use.Ordinal(segmentPieceLengths, segmentPieceLengthsIndex);
    });
};


;// CONCATENATED MODULE: ./src/material/custom/segmentPieceLength/segmentIntervals.ts

var computeSegmentIntervals = function (_a) {
    var entityCount = _a.entityCount, segmentIndex = _a.segmentIndex, coreIntervals = _a.coreIntervals;
    return (0,utilities_.cycleSlice)(coreIntervals, (0,utilities_.insteadOf)(segmentIndex), utilities_.use.Cardinal(utilities_.use.Cardinal(segmentIndex, (0,utilities_.insteadOf)(entityCount)), utilities_.DECREMENT));
};


;// CONCATENATED MODULE: ./src/material/custom/segmentPieceLength/segmentPieceLengthsFromSegmentRatios.ts
var segmentPieceLengthsFromSegmentRatios_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var segmentPieceLengthsFromSegmentRatios_spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};

var computeSegmentPieceLengthsFromSegmentRatios = function (segmentRatios) {
    var segmentRatiosInCommonTerms = utilities_.computeCommonTerms.apply(void 0, segmentPieceLengthsFromSegmentRatios_spreadArray([], segmentPieceLengthsFromSegmentRatios_read(segmentRatios), false));
    var numerators = segmentRatiosInCommonTerms.map(utilities_.getNumerator);
    var leastCommonMultipleOfNumerators = utilities_.computeLeastCommonMultiple.apply(void 0, segmentPieceLengthsFromSegmentRatios_spreadArray([], segmentPieceLengthsFromSegmentRatios_read(numerators), false));
    return numerators
        .map(function (numerator) {
        return utilities_.as.Numerator((0,utilities_.round)((0,utilities_.quotient)(leastCommonMultipleOfNumerators, numerator)));
    })
        .map(function (numerator) { return utilities_.as.Cardinal(utilities_.as.number(numerator)); });
};


;// CONCATENATED MODULE: ./src/material/custom/segmentPieceLength/segmentRatios.ts

var computeSegmentRatios = function (_a) {
    var segmentIntervals = _a.segmentIntervals;
    var segmentRatios = [utilities_.RATIONAL_IDENTITY];
    segmentIntervals.forEach(function (segmentInterval) {
        var nextSegmentRatio = (0,utilities_.multiplyRationals)((0,utilities_.finalElement)(segmentRatios), segmentInterval);
        segmentRatios.push(nextSegmentRatio);
    });
    return segmentRatios;
};


;// CONCATENATED MODULE: ./src/material/custom/segmentPieceLength/segmentPieceLengths.ts




var computeSegmentPieceLengths = function (_a) {
    var coreIntervals = _a.coreIntervals, entityCount = _a.entityCount, segmentIndex = _a.segmentIndex, segmentValueIndices = _a.segmentValueIndices;
    var segmentIntervals = computeSegmentIntervals({ segmentIndex: segmentIndex, coreIntervals: coreIntervals, entityCount: entityCount });
    var segmentRatios = computeSegmentRatios({ segmentIntervals: segmentIntervals });
    var segmentPieceLengthsFromSegmentRatios = computeSegmentPieceLengthsFromSegmentRatios(segmentRatios);
    return alignSegmentPieceLengthsWithSegmentValues({
        segmentPieceLengths: segmentPieceLengthsFromSegmentRatios,
        segmentValueIndices: segmentValueIndices,
    });
};


;// CONCATENATED MODULE: ./src/material/custom/segmentPieceLength/index.ts


;// CONCATENATED MODULE: ./src/material/custom/equalizeValuesOfSegmentNotes.ts
var equalizeValuesOfSegmentNotes_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var equalizeValuesOfSegmentNotes_spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};



var equalizeValuesOfSegmentNotes = function (segments) {
    var equalizedSegments = (0,utilities_.deepClone)(segments);
    (0,utilities_.forEach)(segments, function (segment, segmentIndex) {
        var notesValues = segment.map(material_.computeNotesValueScalarSum);
        var maxNotesValue = utilities_.max.apply(void 0, equalizeValuesOfSegmentNotes_spreadArray([], equalizeValuesOfSegmentNotes_read(notesValues), false));
        var neededAdjustments = notesValues.map(function (notesValue) {
            return (0,utilities_.difference)(maxNotesValue, notesValue);
        });
        (0,utilities_.forEach)(neededAdjustments, function (neededAdjustment, notesIndex) {
            if (neededAdjustment <=
                ADJUSTMENT_SIZE_BELOW_WHICH_IT_MATTERS_NOT_AND_BREAKS_THE_TOTAL_DURATION_CALCULATION) {
                return;
            }
            var equalizedSegment = utilities_.use.Ordinal(equalizedSegments, segmentIndex);
            var equalizedNotes = utilities_.use.Ordinal(equalizedSegment, (0,utilities_.insteadOf)(notesIndex));
            var equalizedNote = (0,utilities_.finalElement)(equalizedNotes);
            // tslint:disable-next-line no-non-null-assertion
            equalizedNote.value.scalar = utilities_.use.Translation(
            // tslint:disable-next-line no-non-null-assertion
            equalizedNote.value.scalar, utilities_.as.Translation(neededAdjustment));
        });
    });
    return equalizedSegments;
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/initialEmptyEntitiesNotes.ts

var computeInitialEmptyEntitiesNotes = function (_a) {
    var entityCount = _a.entityCount;
    var initialEmptyEntitiesNotes = [];
    for (var entityIndex = utilities_.INITIAL; entityIndex < utilities_.as.Ordinal(utilities_.as.number(entityCount)); entityIndex = utilities_.use.Cardinal(entityIndex, utilities_.NEXT)) {
        initialEmptyEntitiesNotes.push([]);
    }
    return initialEmptyEntitiesNotes;
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/loopCount.ts

var computeLoopCount = function (_a) {
    var entityCount = _a.entityCount, cycleLength = _a.cycleLength;
    return utilities_.as.Cardinal((0,utilities_.quotient)((0,utilities_.computeLeastCommonMultiple)(entityCount, cycleLength), utilities_.as.number(cycleLength)));
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/loopCycledSegmentSegments.ts

var computeLoopCycledSegmentSegments = function (_a) {
    var loopSegmentCycleShift = _a.loopSegmentCycleShift, segments = _a.segments, loopIndex = _a.loopIndex;
    var loopCycling = utilities_.use.Multiple(loopSegmentCycleShift, utilities_.as.Multiple(utilities_.as.number(loopIndex)));
    return segments.map(function (segment) {
        var cycle = utilities_.use.Cardinal(utilities_.as.Cycle(segment), loopCycling);
        return utilities_.as.unbrandedArray(cycle);
    });
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/loopSegmentCycleShifts.ts

var computeLoopSegmentCycleShift = function (_a) {
    var cycleLength = _a.cycleLength, entityCount = _a.entityCount;
    return (0,utilities_.insteadOf)((0,utilities_.negative)(utilities_.use.Remaindee(cycleLength, utilities_.as.Remaindee(utilities_.as.number(entityCount)))));
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/segmentsDimensions.ts

var computeSegmentsDimensions = function (segments) {
    var entityCount = (0,utilities_.insteadOf)((0,utilities_.computeLength)((0,utilities_.exampleElement)(segments)));
    var cycleLength = (0,utilities_.computeLength)(segments);
    return {
        cycleLength: cycleLength,
        entityCount: entityCount,
    };
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/distributeSegmentsToEntities.ts






var distributeSegmentToEntities = function (_a) {
    var segments = _a.segments, existingEntitiesNotes = _a.existingEntitiesNotes;
    var populatedEntitiesNotes = (0,utilities_.deepClone)(existingEntitiesNotes);
    segments.forEach(function (segment) {
        (0,utilities_.forEach)(segment, function (notes, notesIndex) {
            (0,utilities_.arraySet)(populatedEntitiesNotes, notesIndex, (0,utilities_.sequence)(utilities_.use.Ordinal(populatedEntitiesNotes, notesIndex), notes));
        });
    });
    return populatedEntitiesNotes;
};
var distributeSegmentsToEntities = function (segments) {
    var segmentsDimensions = computeSegmentsDimensions(segments);
    var populatedEntitiesNotes = computeInitialEmptyEntitiesNotes(segmentsDimensions);
    var loopCount = computeLoopCount(segmentsDimensions);
    var loopSegmentCycleShift = computeLoopSegmentCycleShift(segmentsDimensions);
    for (var loopIndex = utilities_.INITIAL; loopIndex < utilities_.as.Ordinal(utilities_.as.number(loopCount)); loopIndex = utilities_.use.Cardinal(loopIndex, utilities_.INCREMENT)) {
        var loopCycledSegmentSegments = computeLoopCycledSegmentSegments({
            loopIndex: loopIndex,
            loopSegmentCycleShift: loopSegmentCycleShift,
            segments: segments,
        });
        populatedEntitiesNotes = distributeSegmentToEntities({
            existingEntitiesNotes: populatedEntitiesNotes,
            segments: loopCycledSegmentSegments,
        });
    }
    return populatedEntitiesNotes;
};


;// CONCATENATED MODULE: ./src/material/custom/distributeSegmentsToEntities/index.ts


// EXTERNAL MODULE: external "@musical-patterns/spec"
var spec_ = __webpack_require__(918);
;// CONCATENATED MODULE: ./src/nominals.ts

var beatenPathAs = (0,utilities_.computeNominalInterface)({
    number: {
        Core: utilities_.DUMMY_VALUE_FOR_COMPUTING_NOMINAL_INTERFACE,
        Repetition: utilities_.DUMMY_VALUE_FOR_COMPUTING_NOMINAL_INTERFACE,
    },
}).as;


;// CONCATENATED MODULE: ./src/spec/types.ts
var BeatenPathStyle;
(function (BeatenPathStyle) {
    BeatenPathStyle["POLYRHYTHMIC"] = "POLYRHYTHMIC";
    BeatenPathStyle["SMOOTH"] = "SMOOTH";
})(BeatenPathStyle || (BeatenPathStyle = {}));


;// CONCATENATED MODULE: ./src/spec/constants.ts
// tslint:disable no-magic-numbers



var BEATEN_PATH_INITIAL_CORE = beatenPathAs.Core(5);
var BEATEN_PATH_INITIAL_HZ_PHYSICALIZATION = utilities_.SCIENTIFIC_PITCHES[utilities_.ScientificPitchNoteName.A][utilities_.ScientificPitchOctaveNumber._3];
var BEATEN_PATH_INITIAL_REVERSE = false;
var BEATEN_PATH_INITIAL_STYLE = BeatenPathStyle.POLYRHYTHMIC;
var BEATEN_PATH_INITIAL_ENTITY_COUNT = utilities_.as.Cardinal(2);
var BEATEN_PATH_MINIMUM_FUNCTIONAL_CORE = beatenPathAs.Core(2);
var PRESET_BALANCED_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(500);
var PRESET_BALANCED_CORE = beatenPathAs.Core(3);
var PRESET_BALANCED_ENTITY_COUNT = utilities_.as.Cardinal(3);
var PRESET_DENSE_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(369);
var PRESET_DENSE_CORE = beatenPathAs.Core(2);
var PRESET_DENSE_HZ_PHYSICALIZATION = utilities_.SCIENTIFIC_PITCHES[utilities_.ScientificPitchNoteName.B][utilities_.ScientificPitchOctaveNumber._3];
var PRESET_DENSE_ENTITY_COUNT = utilities_.as.Cardinal(4);
var PRESET_DENSE_REPETITIONS = utilities_.as.Cardinal(4);
var PRESET_PRIMAL_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(3);
var PRESET_PRIMAL_HZ_PHYSICALIZATION = utilities_.SCIENTIFIC_PITCHES[utilities_.ScientificPitchNoteName.A][utilities_.ScientificPitchOctaveNumber._4];
var PRESET_PRIMAL_CORE = beatenPathAs.Core(12);
var PRESET_PRIMAL_ENTITY_COUNT = utilities_.as.Cardinal(3);
var PRESET_ROUND_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(20);
var PRESET_ROUND_HZ_PHYSICALIZATION = utilities_.SCIENTIFIC_PITCHES[utilities_.ScientificPitchNoteName.C_SHARP_D_FLAT][utilities_.ScientificPitchOctaveNumber._4];
var PRESET_ROUND_CORE = beatenPathAs.Core(2);
var PRESET_ROUND_ENTITY_COUNT = utilities_.as.Cardinal(7);
var PRESET_ISOLATE_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(180);
var PRESET_ISOLATE_ENTITY_COUNT = utilities_.as.Cardinal(1);
var PRESET_ISOLATE_CORE = beatenPathAs.Core(3);


;// CONCATENATED MODULE: ./src/spec/configurations.ts
var __assign = (undefined && undefined.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};




var styleConstraint = [
    {
        order: 1,
        value: BeatenPathStyle.POLYRHYTHMIC,
    },
    {
        order: 2,
        value: BeatenPathStyle.SMOOTH,
    },
];
styleConstraint.required = true;
var configurations = __assign(__assign({}, spec_.standardConfigurations), { core: {
        constraint: {
            integer: true,
            min: utilities_.as.number(BEATEN_PATH_MINIMUM_FUNCTIONAL_CORE),
            required: true,
        },
        description: "every bar will consist of a harmony and polyrhythm of this value against itself either plus or minus 1",
        hideInput: spec_.RangedInputType.RANGE,
        inputType: spec_.InputType.RANGED,
        order: 1,
    }, entityCount: {
        constraint: {
            integer: true,
            min: 1,
            required: true,
        },
        hideInput: spec_.RangedInputType.RANGE,
        inputType: spec_.InputType.RANGED,
        order: 2,
    }, repetitions: {
        constraint: {
            integer: true,
            min: 1,
        },
        hideInput: spec_.RangedInputType.RANGE,
        inputType: spec_.InputType.RANGED,
        order: 4,
    }, reverse: {
        inputType: spec_.InputType.TOGGLED,
        order: 5,
    }, style: {
        constraint: styleConstraint,
        inputType: spec_.InputType.OPTIONED,
        order: 3,
    } });


;// CONCATENATED MODULE: ./src/spec/initials.ts
var initials_assign = (undefined && undefined.__assign) || function () {
    initials_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return initials_assign.apply(this, arguments);
};
var _a;


var initialSpecs = initials_assign(initials_assign({}, spec_.standardInitialSpecs), (_a = {}, _a[spec_.StandardSpec.HZ_PHYSICALIZATION] = BEATEN_PATH_INITIAL_HZ_PHYSICALIZATION, _a.core = BEATEN_PATH_INITIAL_CORE, _a.entityCount = BEATEN_PATH_INITIAL_ENTITY_COUNT, _a.repetitions = undefined, _a.reverse = BEATEN_PATH_INITIAL_REVERSE, _a.style = BEATEN_PATH_INITIAL_STYLE, _a));


;// CONCATENATED MODULE: ./src/spec/presets.ts
// tslint:disable max-file-line-count
var presets_assign = (undefined && undefined.__assign) || function () {
    presets_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return presets_assign.apply(this, arguments);
};
var presets_a, _b, _c, _d, _e;




var presets = {
    balanced: {
        description: 'not too many entities, not too complex a core, this porridge is just right',
        order: 2,
        specs: presets_assign(presets_assign({}, initialSpecs), (presets_a = {}, presets_a[spec_.StandardSpec.MS_PHYSICALIZATION] = PRESET_BALANCED_MS_PHYSICALIZATION, presets_a.core = PRESET_BALANCED_CORE, presets_a.entityCount = PRESET_BALANCED_ENTITY_COUNT, presets_a.reverse = true, presets_a)),
    },
    dense: {
        description: 'leaning toward more entities but simpler core, for an etherial effect',
        order: 1,
        specs: presets_assign(presets_assign({}, initialSpecs), (_b = {}, _b[spec_.StandardSpec.MS_PHYSICALIZATION] = PRESET_DENSE_MS_PHYSICALIZATION, _b[spec_.StandardSpec.HZ_PHYSICALIZATION] = PRESET_DENSE_HZ_PHYSICALIZATION, _b.core = PRESET_DENSE_CORE, _b.entityCount = PRESET_DENSE_ENTITY_COUNT, _b.repetitions = PRESET_DENSE_REPETITIONS, _b)),
    },
    entropic: {
        description: 'simple illustration of entities movement, with a sufficiently interestingly complex core',
        order: 0,
        specs: initialSpecs,
    },
    isolate: {
        description: 'isolating the core cycle',
        order: 5,
        specs: presets_assign(presets_assign({}, initialSpecs), (_c = {}, _c[spec_.StandardSpec.MS_PHYSICALIZATION] = PRESET_ISOLATE_MS_PHYSICALIZATION, _c.core = PRESET_ISOLATE_CORE, _c.entityCount = PRESET_ISOLATE_ENTITY_COUNT, _c)),
    },
    primal: {
        description: 'demonstration of the power of the 11th and 13th harmonics',
        order: 3,
        specs: presets_assign(presets_assign({}, initialSpecs), (_d = {}, _d[spec_.StandardSpec.MS_PHYSICALIZATION] = PRESET_PRIMAL_MS_PHYSICALIZATION, _d[spec_.StandardSpec.HZ_PHYSICALIZATION] = PRESET_PRIMAL_HZ_PHYSICALIZATION, _d.core = PRESET_PRIMAL_CORE, _d.entityCount = PRESET_PRIMAL_ENTITY_COUNT, _d.style = BeatenPathStyle.SMOOTH, _d)),
    },
    round: {
        description: 'testing the limits of the entity density',
        order: 4,
        specs: presets_assign(presets_assign({}, initialSpecs), (_e = {}, _e[spec_.StandardSpec.MS_PHYSICALIZATION] = PRESET_ROUND_MS_PHYSICALIZATION, _e[spec_.StandardSpec.HZ_PHYSICALIZATION] = PRESET_ROUND_HZ_PHYSICALIZATION, _e.core = PRESET_ROUND_CORE, _e.entityCount = PRESET_ROUND_ENTITY_COUNT, _e.reverse = true, _e.style = BeatenPathStyle.SMOOTH, _e)),
    },
};


;// CONCATENATED MODULE: ./src/spec/specs.ts



var spec = {
    configurations: configurations,
    initialSpecs: initialSpecs,
    presets: presets,
};


;// CONCATENATED MODULE: ./src/spec/index.ts



;// CONCATENATED MODULE: ./src/material/constants.ts
// tslint:disable no-magic-numbers

var ENVELOPE_AMOUNT = utilities_.as.Scalar(0.9);


;// CONCATENATED MODULE: ./src/material/features.ts
var features_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};


var computeNote = function (_a) {
    var _b = features_read(_a, 2), pitch = _b[0], value = _b[1];
    return ({
        envelope: {
            scalar: utilities_.use.Scalar(utilities_.as.Scalar(value), ENVELOPE_AMOUNT),
        },
        pitch: {
            scalar: utilities_.as.Scalar(pitch),
        },
        value: {
            scalar: utilities_.as.Scalar(value),
        },
    });
};


;// CONCATENATED MODULE: ./src/material/pieces.ts

var computePolyrhythmicPiece = function (_a) {
    var notesValue = _a.notesValue, pieceLength = _a.pieceLength, repetitions = _a.repetitions;
    return utilities_.as.ContourPiece((0,utilities_.repeat)([
        [
            utilities_.as.number((0,utilities_.reciprocal)(notesValue)),
            utilities_.as.number(notesValue),
        ],
    ], utilities_.use.Multiple(pieceLength, utilities_.as.Multiple(utilities_.as.number(repetitions || 1)))));
};
var computeSmoothPiece = function (_a) {
    var notesValue = _a.notesValue, pieceLength = _a.pieceLength, repetitions = _a.repetitions;
    return utilities_.as.ContourPiece([
        [
            utilities_.as.number((0,utilities_.reciprocal)(notesValue)),
            utilities_.as.number(utilities_.use.Scalar(utilities_.use.Scalar(notesValue, utilities_.as.Scalar(utilities_.as.number(repetitions || 1))), utilities_.as.Scalar(utilities_.as.number(pieceLength)))),
        ],
    ]);
};


;// CONCATENATED MODULE: ./src/material/notes.ts



var computeNotes = function (_a) {
    var style = _a.style, pieceLength = _a.pieceLength, notesValue = _a.notesValue, repetitions = _a.repetitions;
    var computePiece = style === BeatenPathStyle.POLYRHYTHMIC ? computePolyrhythmicPiece : computeSmoothPiece;
    return computePiece({
        notesValue: notesValue,
        pieceLength: pieceLength,
        repetitions: repetitions,
    })
        .map(computeNote);
};


;// CONCATENATED MODULE: ./src/material/segments.ts



var computeSegment = function (_a) {
    var coreDurations = _a.coreDurations, coreIntervals = _a.coreIntervals, entityCount = _a.entityCount, repetitions = _a.repetitions, segmentIndex = _a.segmentIndex, style = _a.style;
    var segmentValueIndices = computeSegmentValueIndices({ segmentIndex: segmentIndex, entityCount: entityCount });
    var segmentPieceLengths = computeSegmentPieceLengths({
        coreIntervals: coreIntervals,
        entityCount: entityCount,
        segmentIndex: segmentIndex,
        segmentValueIndices: segmentValueIndices,
    });
    var segmentValues = segmentValueIndices.map(function (segmentValueIndex) {
        return utilities_.use.Ordinal(coreDurations, segmentValueIndex);
    });
    return (0,utilities_.map)(segmentValues, function (notesValue, index) {
        var pieceLength = utilities_.use.Ordinal(segmentPieceLengths, (0,utilities_.insteadOf)(index));
        return computeNotes({ pieceLength: pieceLength, notesValue: notesValue, repetitions: repetitions, style: style });
    });
};
var computeSegments = function (_a) {
    var core = _a.core, entityCount = _a.entityCount, repetitions = _a.repetitions, style = _a.style;
    var _b = computeCoreCycles(core), coreDurations = _b.coreDurations, coreIntervals = _b.coreIntervals;
    var indexOfFirstElementAgainWrappingAroundTheCycle = (0,utilities_.indexJustBeyondFinalElement)(coreDurations);
    var segments = (0,utilities_.range)(indexOfFirstElementAgainWrappingAroundTheCycle)
        .map(function (integer) { return utilities_.as.Ordinal(integer); })
        .map(function (segmentIndex) {
        return computeSegment({ segmentIndex: segmentIndex, entityCount: entityCount, coreIntervals: coreIntervals, repetitions: repetitions, coreDurations: coreDurations, style: style });
    });
    return equalizeValuesOfSegmentNotes(segments);
};


;// CONCATENATED MODULE: ./src/material/custom/smooth/handleMatchOrNoMatch.ts

var noteMatchesPreviousNote = function (currentPitch, pitch) {
    return currentPitch === pitch;
};
var smoothNoteTotalValueNotReachedBeforeMatchingStreakBroke = function (pitchMatchCount, entityCount) {
    return pitchMatchCount < (0,utilities_.insteadOf)(entityCount);
};
var handleMatchOrNoMatch = function (_a) {
    var delayScalarArgument = _a.delayScalar, entityCount = _a.entityCount, value = _a.value, pitch = _a.pitch, pitchMatchCountArgument = _a.pitchMatchCount, pitchToMatchArgument = _a.pitchToMatch, smoothNoteTotalDurationScalarArgument = _a.smoothNoteTotalValueScalar;
    var pitchMatchCount;
    var smoothNoteTotalValueScalar;
    var delayScalar = delayScalarArgument;
    var pitchToMatch = pitchToMatchArgument;
    if (noteMatchesPreviousNote(pitchToMatchArgument, pitch)) {
        pitchMatchCount = utilities_.use.Cardinal(pitchMatchCountArgument, utilities_.INCREMENT);
        smoothNoteTotalValueScalar = utilities_.use.Translation(smoothNoteTotalDurationScalarArgument, utilities_.as.Translation(utilities_.as.number(value)));
    }
    else {
        if (smoothNoteTotalValueNotReachedBeforeMatchingStreakBroke(pitchMatchCountArgument, entityCount)) {
            delayScalar = (0,utilities_.insteadOf)(smoothNoteTotalDurationScalarArgument);
        }
        pitchToMatch = pitch;
        pitchMatchCount = utilities_.as.Cardinal(1);
        smoothNoteTotalValueScalar = (0,utilities_.insteadOf)(value);
    }
    return { pitchMatchCount: pitchMatchCount, smoothNoteTotalValueScalar: smoothNoteTotalValueScalar, delayScalar: delayScalar, pitchToMatch: pitchToMatch };
};


;// CONCATENATED MODULE: ./src/material/custom/smooth/applySmooth.ts
var applySmooth_assign = (undefined && undefined.__assign) || function () {
    applySmooth_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return applySmooth_assign.apply(this, arguments);
};



var smoothNoteTotalValueReached = function (pitchMatchCount, entityCount) {
    return pitchMatchCount === (0,utilities_.insteadOf)(entityCount);
};
var notesEndReached = function (index, notes) {
    return index === (0,utilities_.indexOfFinalElement)(notes);
};
var computeSmoothNote = function (note, smoothNoteTotalValueScalar) { return (applySmooth_assign(applySmooth_assign({}, note), { envelope: applySmooth_assign(applySmooth_assign({}, note.envelope), { scalar: utilities_.use.Scalar(smoothNoteTotalValueScalar, ENVELOPE_AMOUNT) }), value: applySmooth_assign(applySmooth_assign({}, note.value), { scalar: smoothNoteTotalValueScalar }) })); };
var applySmooth = function (notes, entityCount) {
    var smoothNotes = [];
    var pitchToMatch;
    var pitchMatchCount = utilities_.as.Cardinal(0);
    var smoothNoteTotalValueScalar = utilities_.as.Scalar(0);
    var delayScalar = utilities_.as.Scalar(0);
    (0,utilities_.forEach)(notes, function (note, index) {
        // tslint:disable-next-line no-non-null-assertion
        var value = note.value.scalar;
        // tslint:disable-next-line no-non-null-assertion
        var pitch = note.pitch.scalar;
        var applySmoothVariables = handleMatchOrNoMatch({
            delayScalar: delayScalar,
            entityCount: entityCount,
            pitch: pitch,
            pitchMatchCount: pitchMatchCount,
            pitchToMatch: pitchToMatch,
            smoothNoteTotalValueScalar: smoothNoteTotalValueScalar,
            value: value,
        });
        pitchMatchCount = applySmoothVariables.pitchMatchCount;
        smoothNoteTotalValueScalar = applySmoothVariables.smoothNoteTotalValueScalar;
        delayScalar = applySmoothVariables.delayScalar;
        pitchToMatch = applySmoothVariables.pitchToMatch;
        if (notesEndReached(index, notes)) {
            smoothNoteTotalValueScalar = utilities_.use.Translation(smoothNoteTotalValueScalar, utilities_.as.Translation(utilities_.as.number(delayScalar)));
        }
        if (smoothNoteTotalValueReached(pitchMatchCount, entityCount) || notesEndReached(index, notes)) {
            var smoothNote = computeSmoothNote(note, smoothNoteTotalValueScalar);
            smoothNotes.push(smoothNote);
        }
    });
    return {
        delayScalar: delayScalar,
        notes: smoothNotes,
    };
};


;// CONCATENATED MODULE: ./src/material/custom/smooth/pseudocompileDelay.ts


var pseudocompileDelay = function (_a) {
    var delayScalar = _a.delayScalar, msPhysicalization = _a.msPhysicalization, msPhysicalizationTranslation = _a.msPhysicalizationTranslation;
    return utilities_.use.Translation(utilities_.use.Scalar(msPhysicalization, delayScalar), msPhysicalizationTranslation);
};


;// CONCATENATED MODULE: ./src/material/custom/smooth/index.ts



;// CONCATENATED MODULE: ./src/material/custom/entitiesNotes.ts





var computeEntitiesNotes = function (_a) {
    var core = _a.core, entityCount = _a.entityCount, _b = _a.msPhysicalization, msPhysicalization = _b === void 0 ? utilities_.musicalAs.Duration(1) : _b, _c = _a.msPhysicalizationTranslation, msPhysicalizationTranslation = _c === void 0 ? utilities_.as.Translation(0) : _c, repetitions = _a.repetitions, reverse = _a.reverse, style = _a.style;
    var segments = computeSegments({ core: core, entityCount: entityCount, repetitions: repetitions, style: style });
    var entitiesNotes = distributeSegmentsToEntities(segments);
    if (reverse) {
        entitiesNotes = entitiesNotes.map(utilities_.computeReverse);
    }
    var delayScalars = [];
    if (style === BeatenPathStyle.SMOOTH) {
        entitiesNotes = entitiesNotes.map(function (notes) {
            var _a = applySmooth(notes, entityCount), smoothNotes = _a.notes, delayScalar = _a.delayScalar;
            delayScalars.push(delayScalar);
            return smoothNotes;
        });
    }
    else {
        delayScalars = (0,utilities_.range)(entityCount)
            .map(function () { return utilities_.as.Scalar(0); });
    }
    var delays = delayScalars.map(function (delayScalar) { return pseudocompileDelay({
        delayScalar: delayScalar,
        msPhysicalization: msPhysicalization,
        msPhysicalizationTranslation: msPhysicalizationTranslation,
    }); });
    return {
        delays: delays,
        entitiesNotes: entitiesNotes,
    };
};


;// CONCATENATED MODULE: ./src/material/custom/index.ts







;// CONCATENATED MODULE: ./src/material/entities.ts



var materializeEntities = function (specs) {
    var _a = computeEntitiesNotes(specs), delays = _a.delays, entitiesNotes = _a.entitiesNotes;
    var timbreNames = utilities_.as.Cycle([
        material_.TimbreNameEnum.PUTNEY_WAVERING,
        material_.TimbreNameEnum.ORGAN_2,
        material_.TimbreNameEnum.PHONEME_OOH,
        material_.TimbreNameEnum.PHONEME_AH,
    ]);
    return (0,utilities_.map)(entitiesNotes, function (entityNotes, index) { return ({
        delay: utilities_.use.Ordinal(delays, (0,utilities_.insteadOf)(index)),
        sections: [{ notes: entityNotes }],
        timbreName: utilities_.use.Ordinal(timbreNames, (0,utilities_.insteadOf)(index)),
    }); });
};


;// CONCATENATED MODULE: ./src/material/materials.ts


var material = {
    materializeEntities: materializeEntities,
    materializeScales: material_.materializeStandardScales,
};


;// CONCATENATED MODULE: ./src/material/index.ts


;// CONCATENATED MODULE: ./src/metadata/posts.ts
var env = "production";
// tslint:disable-next-line
var post = env !== 'test' && env != 'material' ? (__webpack_require__(377)["default"]) : '';


;// CONCATENATED MODULE: ./src/metadata/metadatas.ts

var metadata = {
    description: post,
    formattedName: 'Beaten Path',
    mostRecentPublish: "2022-10-10T19:03:26.351Z" || 0,
    musicalIdeaIllustrated: 'metric modulation cycles',
    originalPublish: '2018-10-01T07:00:00.000Z',
    version: "1.0.261" || 0,
};


;// CONCATENATED MODULE: ./src/metadata/index.ts


;// CONCATENATED MODULE: ./src/patterns.ts
var patterns_a;




var pattern = {
    id: id_.Id.BEATEN_PATH,
    material: material,
    metadata: metadata,
    spec: spec,
};
var patterns = (patterns_a = {},
    patterns_a[pattern.id] = pattern,
    patterns_a);


;// CONCATENATED MODULE: ./src/index.ts


})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});